function sTh=genLevelFaces(N,m,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('type','simplicial',@(x) ismember(x,{'simplicial','orthotope'}));
  p.parse(varargin{:});
  type=p.Results.type;
  if strcmp(type,'simplicial')
    TessFun=@(N) CartesianGrid.Triangulation(N);
  else
    TessFun=@(N) CartesianGrid.TessHyp(N);
  end
  
  d=length(N);
  beta=CartesianGrid.beta(N);
  if m==0
    Q=diag(N)*CartesianGrid.points(ones(1,d));
    ind=1+beta*Q;
    for k=1:2^d
      sTh(k)=EltMesh(d,m,Q(:,k),1,ind(k));
    end
    return
  end

  L=fc_hypermesh.Combs(1:d,d-m);
  S=CartesianGrid.points(ones(1,d-m));
  nc=size(L,1);
  colors = fc_tools.graphics.selectColors(nc*2^(d-m));
  labName=fc_hypermesh.funLabName(d,m);
  k=1;
  for l=1:nc
    idc=L(l,:);
    idnc=setdiff(1:d,idc);
    [qw,mew]=TessFun(N(idnc));
    nq=size(qw,2);
    for r=1:2^(d-m)
      Q=zeros(d,nq);
      Q(idnc,:)=qw;
      Q(idc,:)=(N(idc)'.*S(:,r))*ones(1,nq);
      sTh(k)=EltMesh(d,m,Q,mew,beta*Q+1,'color',colors(k,:),'label',labName(k));
      k=k+1;
    end
  end
end
